# Contributing to PDJS

This project is work of [many contributors](https://github.com/PagerDuty/pdjs/graphs/contributors).

You're encouraged to submit [pull requests](https://github.com/PagerDuty/pdjs/pulls), [propose features and discuss issues](https://github.com/PagerDuty/pdjs/issues).

In the examples below, substitute your Github username for `contributor` in URLs.

## Create a Topic Branch

Create a topic branch for your feature or bug fix.

```
git checkout master
git pull origin master
git checkout -b my-branch
```

## Write Code

Implement your feature or bug fix.

## Write Documentation

Document any external behavior in the [README](README.md).

## Commit Changes

Make sure git knows your name and email address:

```
git config --global user.name "Your Name"
git config --global user.email "contributor@example.com"
```

Writing good commit logs is important. A commit log should accurately describe what changes were introduced

```
git add ...
git commit
```

## Push

```
git push origin my-branch
```

## Make a Pull Request

Go to https://github.com/PagerDuty/pdjs and select your feature branch.
Click the 'Pull Request' button and fill out the form.


## Check on Your Pull Request

Check your pull request to see whether its been approved or not.

## Be Patient

It's likely that your change will not be merged right away and maintainers might require some changes to your code

## Thank You

Thanks for contributing! We really do value your time and effort.
